from argparse import ArgumentParser
from .store import StoreObject
from . import json


class Config(StoreObject):
    description = 'Your program description goes here'

    @classmethod
    def get_arguments(cls):
        parser = ArgumentParser(description=cls.description)
        parser.add_argument('--config',
            help='Path to config file.',
            type=str, required=True)
        args = parser.parse_args()
        return args

    @classmethod
    def read(cls, pathname):
        obj = cls.read_file(pathname)
        if not obj:
            return None
        c = cls(obj)
        return c

    @classmethod
    def read_file(cls, pathname):
        with open(pathname, 'r', encoding='utf-8') as f:
            c = f.read()
            obj = json.loads(c)
            return obj
        return None

    def validate(self):
        '''
        Returns list of validation error messages.
        Empty list if validation is OK.
        '''
        return []