try:
    import redis
except ImportError:
    raise ImportError('redis must be installed! Command: pip install redis')


class Redis:
    @classmethod
    def connect(cls, host, port):
        r = cls()
        r.conn = redis.StrictRedis(host=host, port=port)
        return r

    def __init__(self):
        self.conn = None

    def expire(self, key, expires):
        self.conn.expire(key, expires)

    def flush_all(self):
        return self.conn.flushall()

    def get(self, key):
        return self.conn.get(key)

    def listing(self, pattern):
        return self.conn.keys(pattern)

    def remove(self, *keys):
        self.conn.delete(*keys)

    def set(self, key, value, expires=None):
        self.conn.set(key, value)
        if expires:
            self.expire(key, expires)